    type
       te32_exe = record
          e32_magic : word;
          e32_border : byte;
          e32_worder : byte;
          e32_level : longint;
          e32_cpu : word;
          e32_os : word;
          e32_ver : longint;
          e32_mflags : longint;
          e32_mpages : longint;
          e32_startobj : longint;
          e32_eip : longint;
          e32_stackobj : longint;
          e32_esp : longint;
          e32_pagesize : longint;
          e32_pageshift : longint;
          e32_fixupsize : longint;
          e32_fixupsum : longint;
          e32_ldrsize : longint;
          e32_ldrsum : longint;
          e32_objtab : longint;
          e32_objcnt : longint;
          e32_objmap : longint;
          e32_itermap : longint;
          e32_rsrctab : longint;
          e32_rsrccnt : longint;
          e32_restab : longint;
          e32_enttab : longint;
          e32_dirtab : longint;
          e32_dircnt : longint;
          e32_fpagetab : longint;
          e32_frectab : longint;
          e32_impmod : longint;
          e32_impmodcnt : longint;
          e32_impproc : longint;
          e32_pagesum : longint;
          e32_datapage : longint;
          e32_preload : longint;
          e32_nrestab : longint;
          e32_cbnrestab : longint;
          e32_nressum : longint;
          e32_autodata : longint;
          e32_debuginfo : longint;
          e32_debuglen : longint;
          e32_instpreload : longint;
          e32_instdemand : longint;
          e32_heapsize : longint;
          e32_res3 : array[0..24-1] of byte;
       end;

       te32_obj = record
          o32_size : longint;
          o32_base : longint;
          o32_flags : longint;
          o32_pagemap : longint;
          o32_mapsize : longint;
          o32_reserved : longint;
       end;

    type
       o32_map = record
          o32_pagedataoffset : longint;
          o32_pagesize : word;
          o32_pageflags : word;
       end;

       taout_exe = record
          magic : longint;
          textlen : longint;
          datalen : longint;
          bsslen : longint;
          symslen : longint;
          startaddr : longint;
          reloctext : longint;
          relocdata : longint;
       end;

       texe = record
          eid : word;
          elast : word;
          epagsiz : word;
          erelcnt : word;

          ehdrsiz : word;
          eminfre : word;
          emaxfre : word;
          eiss : word;

          eisp : word;
          enegsum : word;
          eiip : word;
          eics : word;

          ereloff : word;
          eovlnum : word;
          ever : word;
          dumy : word;
       end;

  const bufsize = 8192;

  procedure seek(var f : file;l : longint);

    var
       i : longint;
       b : byte;

    begin
       if l<=filesize(f) then
         system.seek(f,l)
       else
         begin
            b:=0;
            for i:=filesize(f)+1 to l do
               blockwrite(f,b,1);
         end;
    end;

  var
     le_header : te32_exe;
     aout_header : taout_exe;
     exe_header : texe;

     stackobj,codeobj,dataobj : te32_obj;
     aout,le,pmode : file;

     la : array[0..7] of longint;
     buffer : array[0..bufsize] of char;

     s : integer;

     i : longint;

     w : word;

     stub_with_pmode : boolean;

     b : byte;

  begin
     stub_with_pmode:=true;
     if stub_with_pmode then
       begin
          { open stub }
          assign(pmode,'PMODE\PMODEW.EXE');
          reset(pmode,1);
       end;
     { open aout }
     assign(aout,'TEST\EX5');
     reset(aout,1);
     { open le file }
     assign(le,'TEST\EX5.EXE');
     rewrite(le,1);

     if stub_with_pmode then
       begin
          { write stub }
          { generate header }
          blockread(pmode,exe_header,sizeof(exe_header));
          inc(exe_header.elast,$20);
          inc(exe_header.ereloff,$2);

          blockwrite(le,exe_header,sizeof(exe_header));

          { generate address of LE header }
          fillchar(la,sizeof(la),0);

          { we extended the header }
          la[7]:=filesize(pmode)+$20;

          if la[7] mod 4<>0 then
            inc(la[7],4-(la[7] mod 4));
          blockwrite(le,la,sizeof(la));

          { copy the whole stub file }
          while not(eof(pmode)) do
            begin
               blockread(pmode,buffer,bufsize,s);
               blockwrite(le,buffer,s);
            end;
          close(pmode);
       end
     else
       la[7]:=0;
     { goto start of LE header }
     seek(le,la[7]);

     { read aout header }
     blockread(aout,aout_header,sizeof(aout_header));

     codeobj.o32_size:=aout_header.textlen;
     codeobj.o32_base:=$1000;
     codeobj.o32_flags:=$2045; { executable, readable, preload and big }
     codeobj.o32_pagemap:=1;

     { only datasegment contains data }
     codeobj.o32_mapsize:=aout_header.textlen div 4096+1;
     codeobj.o32_reserved:=0;

     dataobj.o32_size:=aout_header.datalen+aout_header.bsslen;
     dataobj.o32_base:=$4000000;
     dataobj.o32_flags:=$2043; { readable, writeable, preload and big }
     dataobj.o32_pagemap:=codeobj.o32_mapsize+1;
     dataobj.o32_mapsize:=aout_header.datalen div 4096+1;
     dataobj.o32_reserved:=0;

     { 1M stack }
     stackobj.o32_size:=$1000*16;
     stackobj.o32_base:=$7ffffff-stackobj.o32_size+1;
     stackobj.o32_flags:=$2043; { readable, writeable, preload and big }
     stackobj.o32_pagemap:=dataobj.o32_pagemap+1;;
     { no data for the stack }
     stackobj.o32_mapsize:=0;
     stackobj.o32_reserved:=0;

     { set values in le_header }
     le_header.e32_magic:=$454c; { LE }
     le_header.e32_border:=0; { little endian }
     le_header.e32_worder:=0; { little endian }
     le_header.e32_level:=0; { format 0 }
     le_header.e32_cpu:=2; { 80386 }
     le_header.e32_os:=1; { OS/2 }
     le_header.e32_ver:=0; { module version }

     { fixups are removed }
     le_header.e32_mflags:=$230;

     { determine pages }
     le_header.e32_mpages:=codeobj.o32_mapsize+dataobj.o32_mapsize;

     { set start address }
     le_header.e32_startobj:=1;
     le_header.e32_eip:=aout_header.startaddr;

     le_header.e32_stackobj:=3;
     le_header.e32_esp:=stackobj.o32_size;

     { 4096 bytes per page }
     le_header.e32_pagesize:=$1000;

     { I don't know what this means }
     le_header.e32_pageshift:=$23;

     { no fixups }
     le_header.e32_fixupsize:=0;
     le_header.e32_fixupsum:=0;

     le_header.e32_ldrsize:=
       { 3 objects }
       sizeof(te32_obj)*3+

       { determine page map size }
       (codeobj.o32_mapsize+dataobj.o32_mapsize)*4+

       { entry table }
       1;

     le_header.e32_ldrsum:=0;

     le_header.e32_objtab:=sizeof(le_header);

     { always three objects }
     le_header.e32_objcnt:=3;

     le_header.e32_objmap:=le_header.e32_objtab+sizeof(te32_obj)*
       le_header.e32_objcnt;

     le_header.e32_itermap:=0;

     le_header.e32_rsrctab:=le_header.e32_objmap+
       4*(dataobj.o32_mapsize+codeobj.o32_mapsize);

     le_header.e32_rsrccnt:=0;

     le_header.e32_restab:=le_header.e32_rsrctab;
     le_header.e32_enttab:=le_header.e32_restab;

     { no module directives }
     le_header.e32_dirtab:=0;
     le_header.e32_dircnt:=0;

     { no fixups }
     le_header.e32_fpagetab:=0;
     le_header.e32_frectab:=0;

     { no imported modules }
     le_header.e32_impmod:=le_header.e32_enttab+1;
     le_header.e32_impmodcnt:=$0;

     le_header.e32_impproc:=le_header.e32_impmod;

     { we use no check sum }
     le_header.e32_pagesum:=0;

     { start of the data pages }
     le_header.e32_datapage:=la[7]+le_header.e32_impproc;

     { align to 256 bytes }
     inc(le_header.e32_datapage,256-le_header.e32_datapage mod 256);

     le_header.e32_preload:=$0;
     le_header.e32_nrestab:=$0;
     le_header.e32_cbnrestab:=$0;
     le_header.e32_nressum:=$0;
     le_header.e32_autodata:=$0;
     le_header.e32_debuginfo:=$0;
     le_header.e32_debuglen:=$0;
     le_header.e32_instpreload:=$0;
     le_header.e32_instdemand:=$0;
     le_header.e32_heapsize:=$0;

     { write header }
     blockwrite(le,le_header,sizeof(le_header));

     { write object tables }
     blockwrite(le,codeobj,sizeof(codeobj));
     blockwrite(le,dataobj,sizeof(dataobj));
     blockwrite(le,stackobj,sizeof(stackobj));

     { write page map }
     for i:=1 to le_header.e32_mpages do
       begin
          w:=0;
          blockwrite(le,w,2);
          w:=i;
          blockwrite(le,w,2);
       end;

     { write entry table }
     b:=0;
     blockwrite(le,b,1);

     { write pages }
     { goto start of data }
     seek(le,le_header.e32_datapage);

     { write text segment }
     for i:=1 to aout_header.textlen do
       begin
          blockread(aout,buffer,1);
          blockwrite(le,buffer,1);
       end;

     { align to page }
     seek(le,le_header.e32_datapage+codeobj.o32_mapsize*4096);

     { write data segment }
     for i:=1 to aout_header.datalen do
       begin
          blockread(aout,buffer,1);
          blockwrite(le,buffer,1);
       end;
     { make a full page }
     seek(le,le_header.e32_datapage+codeobj.o32_mapsize*4096+
       dataobj.o32_mapsize*4096);

     close(le);
     close(aout);
  end.